#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/select.h>
#include <signal.h>
#include "keys.h"

const int noecho = 1 ;

int
main(int ac,char *av[])
{
    int c;
    fd_set readers,readfds;
    struct keytype key;

    if (noecho) system("stty raw");
    FD_SET(STDIN,&readers);
    for(;;) {
        readfds = readers;
        c = select(1,&readfds,(fd_set *)0,(fd_set *)0,
                                                (struct timeval *)0);
	if (c<=0) return 1;
	if (! FD_ISSET(0,&readers)) return 2;
	c=read(STDIN,key.buf,1);
	if (c<=0) return 3;
	gettimeofday(&key.tp,0);
	write(STDOUT,&key,sizeof(key));
	if (noecho) write(STDERR,&key.buf[0],1);
	if (key.buf[0]==4) return 0; /* ^D */
    }
    return 0;
}

